// Interrupt-Sequenz 
// Debounce up to 8 states

 static uint8_t ct0, ct1, ct2, rpt;
  uint8_t  tc_key_inp, chg;
  if (!((~KEY_DDR & KEY_MASK) ^ KEY_MASK)) {     // check for input
  tc_key_inp = (KEY_PORT ^ KEY_XOR) & KEY_MASK; 
  chg = key_state;                               // chg is the trigger to set key_press 
  key_state = (ct2 & ct1 & ct0 & tc_key_inp);    // then toggle debounced state
  chg ^= key_state;
  ct2 = ct1 & ct0 & tc_key_inp;                 // Interstate 2
  ct1 = ct0 & tc_key_inp;                       // Interstate 1
  ct0 = tc_key_inp;                             // remember last state
  if (chg) key_press |= key_state;                       // 0->1: key press detect
  if( (key_state & KEY_REPEAT_MASK) == 0 )            // check repeat function
     rpt = KEY_REPEAT_START;                          // start delay
  if (rpt) if( --rpt == 0 ){                          // if REPEAT_NEXT=0, there is no second shot
    rpt = KEY_REPEAT_NEXT;                            // repeat delay time in cycles
    key_rpt |= key_state & TC_KEY_REPEAT_MASK;};
}; };
